
#import logging.handlers
import traceback,re
import json
import sys, argparse,os
import tarfile
import subprocess
import logging
from fastapi import FastAPI
from typing import Union
import logging
from pydantic import BaseModel
import uvicorn
import datetime
#from fastapi.middleware.cors import CORSMiddleware
from utils.restApi import RESTClient
from utils.utils import sysapp
import shutil
from fastapi import APIRouter
import threading


class Item(BaseModel):
    json_str: str

restObj = RESTClient()
# urlFmt = "https://%s:%s/%s"
# host = "172.17.0.14"
# port="31366"
urlFmt = "https://%s/%s"
host = "cmdb.epm2demo.cn"
tokenHeader = {'Authorization': 'YWRtaW46JjNVZUBURjlVcSo3dGdKQA==', 'Content-Type': 'application/json'}

appDir='/data_disk/APP'
#appList=['ehualupg','msinspg2','msinspg']
buildDir='/data_disk/UPLOAD/sys'
version_file = f'{buildDir}/UPDATE_VERSION'

router = APIRouter()

def untar(tar_file_path, destination_dir):
    with tarfile.open(tar_file_path, 'r') as tar:
        tar.extractall(path=destination_dir)

def update_app1(sys_name,latest_file): 
    try:   
        sysapp.info(f'{sys_name} untar')
        nm_path = os.path.join(appDir, sys_name, 'node_modules')
        if os.path.exists(nm_path):
            shutil.rmtree(nm_path)
        untar(os.path.join(buildDir, latest_file),os.path.join(appDir, sys_name))
        original_name='%s/%s/%s'%(appDir, sys_name,'backend.js')
        new_name='%s/%s/%s_%s'%(appDir,sys_name, sys_name, 'backend.js')
        os.rename(original_name, new_name)
        #etl
        original_name='%s/%s/%s'%(appDir,sys_name, 'etl_worker.js')
        new_name='%s/%s/%s_%s'%(appDir, sys_name,sys_name, 'etl_worker.js')
        os.rename(original_name, new_name)
        #agenda
        original_name='%s/%s/%s'%(appDir,sys_name, 'agenda_dev.js')
        new_name='%s/%s/%s_%s'%(appDir, sys_name,sys_name, 'agenda_dev.js')
        os.rename(original_name, new_name)

        sysapp.info(f'{sys_name} untar success')

        # for app1 in ['backend', 'etl_worker', 'agenda_dev']:
        #     cmd=f"pm2 reload {sys_name}_{app1}"
        #     sysapp.info(cmd)
        #     result = subprocess.run(cmd, shell=True, capture_output=True, text=True)
        #     sysapp.info(result) 
        #     if result.returncode == 0:
        #         sysapp.info(f"{sys_name} {app1} updateApp success")
        #         rsp='success'
        #     else:
        #         sysapp.error(f"{sys_name} {app1} updateApp fail")
    except Exception as e:
        sysapp.error(f"{sys_name} updateApp fail {e}")

def update_app_handler(name,item_in):
    sysapp.info(f"update_app_handler, thread name: {name}, item_in:{item_in}")
    try:
        sys_name_spe = None
        if item_in is not None:
            json_str = item_in.json_str
            json_obj = json.loads(json_str)
            sysapp.debug(f"update_item: {json_obj}")     
            sys_name_spe=json_obj['sys_name']

        rsp='fail'
        #/:envId/:typeName/:showClose
        restPath='epm/sys/698/postgre/false'
        url = urlFmt % (host, restPath)
        sysapp.info(url)
        response = restObj.get(url, headers=tokenHeader)
        sysapp.info(response.content)
        restObj.checkResponse(response.status_code)

        #find master build
        pattern = r'cons-build-cons_master.*node20.tar$'
        matching_files = [file for file in os.listdir(buildDir) if os.path.isfile(os.path.join(buildDir, file)) and re.search(pattern, file)]
        # search_string='master'
        # matching_files = [file for file in os.listdir(buildDir) if os.path.isfile(os.path.join(buildDir, file)) and search_string in file and file.endswith('tar')]                
        master_latest_file = max(matching_files, key=lambda x: os.path.getctime(os.path.join(buildDir, x)))
        sysapp.info(f'matching master_latest_file: {master_latest_file}')

        # Open the file in read mode
        try:
            with open(version_file, 'r') as file:
                # Read the content of the file into a string
                file_content = file.read()                  
        except:
            file_content = ''
        sysapp.info(f"current version: {file_content}")   
        if sys_name_spe is None and file_content == master_latest_file:
            sysapp.info('current version is latest, skip')
            rsp = 'success'
            return rsp

        threadAry = []        
        for app in response.json():            
            sys_name=app['sys_name']
            sysapp.debug(f"sys_name {sys_name}")
            try:
                if sys_name_spe and sys_name_spe!= sys_name:
                    continue                    
                auto_update=app['auto_update']
                if sys_name_spe is None and not auto_update:
                    sysapp.info(f"{sys_name} auto_update is false, skip")
                    continue                
                branch_name=app['branch']
                #if app['sys_name'] in appList:
                sysapp.info('updating %s, branch: %s'%(sys_name, branch_name))
                #find target tar
                latest_file=master_latest_file
                if branch_name:
                    search_string=branch_name
                    matching_files = [file for file in os.listdir(buildDir) if os.path.isfile(os.path.join(buildDir, file)) and search_string in file and file.endswith('tar')]       
                    if len(matching_files) > 0:      
                        latest_file = max(matching_files, key=lambda x: os.path.getctime(os.path.join(buildDir, x)))               
                        sysapp.info('release branch,search_string %s, matching files: %s, latest_file: %s'%(search_string,matching_files,latest_file))
                    else:
                        sysapp.info('no build found for branch,skip')
                        continue

                threadi = threading.Thread(target=update_app1,args=(sys_name,latest_file,))
                threadi.start()
                threadAry.append(threadi)

                # sysapp.info('untar')
                # #os.removedirs(os.path.join(appDir, app['sys_name'], 'node_modules'))
                # nm_path = os.path.join(appDir, sys_name, 'node_modules')
                # if os.path.exists(nm_path):
                #     shutil.rmtree(nm_path)
                # untar(os.path.join(buildDir, latest_file),os.path.join(appDir, app['sys_name']))
                # original_name='%s/%s/%s'%(appDir, sys_name,'backend.js')
                # new_name='%s/%s/%s_%s'%(appDir,sys_name, app['sys_name'], 'backend.js')
                # os.rename(original_name, new_name)
                # #etl
                # original_name='%s/%s/%s'%(appDir,sys_name, 'etl_worker.js')
                # new_name='%s/%s/%s_%s'%(appDir, sys_name,sys_name, 'etl_worker.js')
                # os.rename(original_name, new_name)
                # #agenda
                # original_name='%s/%s/%s'%(appDir,sys_name, 'agenda_dev.js')
                # new_name='%s/%s/%s_%s'%(appDir, sys_name,sys_name, 'agenda_dev.js')
                # os.rename(original_name, new_name)
                
                # for app1 in ['backend', 'etl_worker', 'agenda_dev']:
                #     cmd=f"pm2 reload {sys_name}_{app1}"
                #     sysapp.info(cmd)
                #     result = subprocess.run(cmd, shell=True, capture_output=True, text=True)
                #     sysapp.info(result) 
                #     if result.returncode == 0:
                #         sysapp.info(f"{sys_name} {app1} updateApp success")
                #         rsp='success'
                #     else:
                #         sysapp.error(f"{sys_name} {app1} updateApp fail")


            except Exception as e:
                sysapp.error(f"updateApp {sys_name} fail, {e}")

        sysapp.info('all threads start')
        for thread in threadAry:
            thread.join()
        sysapp.info("untar all success")  
        cmd=f"pm2 reload all"
        sysapp.info(cmd)
        result = subprocess.run(cmd, shell=True, capture_output=True, text=True)
        sysapp.info(result) 
        if result.returncode == 0:
            sysapp.info("updateApp all success, update version file")
            # Open the file in write mode
            with open(version_file, 'w') as file:
                # Write some text to the file
                file.write(master_latest_file)
        else:
            sysapp.info("updateApp all fail")       
        
    except Exception as e:
        sysapp.error(e)
        return {"error": str(e)}
    return rsp

@router.put(
    "/update_app"
)
def update_app(item_in: Item):
    sysapp.info('update_app1')
    thread1 = threading.Thread(target=update_app_handler, args=("Thread 1",item_in,)) 
    thread1.start()
    return 'success'
